#include <iostream>
#include <vector>
#include <string>
using namespace std;

/* 
 CONSTAT : c'est un bon début, mais :
   1) manque de structuration des données  : identifier les CONCEPTS clés
   2) manque de modularisation (fonctions) : intentifier les TRAITEMENTS clés
   3) Généricité : on ne peut faire que de la fondue ; pourquoi pas autre chose ? facile ?

mineurs/plus tard:
   4) rendre la saisie plus robuste : do-while
   5) simplifier/améliorer l'affichage
*/

// ======================================================================
struct Ingredient {
  string nom;
  double qtt;
  string unite;
};

// ======================================================================
struct Recette {
  string titre;
  int nb_convives;     // nombre de personnes pour la recette de base
  vector<Ingredient> ingredients;
};

// ======================================================================
  /* On supposera pour cet exercice que l'utilisateur ne saisit que
   * des valeurs strictement positives mais nous pourrions faire mieux.
   */
int demander_nb_convives()
{
  cout << "Entrez le nombre de personnes conviées à la fondue : ";
  int nb_convives;
  cin >> nb_convives;
  return nb_convives;
}

// ======================================================================
// « adapter » ou « mettre à jour »
// Deux choix possibles :
//     void adapter(Fondue& f);
// ou  Fondue adapter(Fondue const& f);
Recette adapter(Recette const& recette, int nb_convives)
{
  Recette retour(recette);
  
  // Mise à jour des quantités en fonction du nombre de convives :
  retour.nb_convives = nb_convives;

  double ratio(nb_convives);      // Notez le 'double' ici...
  ratio /= recette.nb_convives ; // ... pour éviter une division entière.
  
  // on modifie ==> donc ne pas oublier le & !
  for (auto& ingredient : retour.ingredients) {
    ingredient.qtt *= ratio;
  }

  return retour;
}

// ======================================================================
void afficher(Ingredient const& i)
{
  cout << i.qtt << ' ' << i.unite << " de " << i.nom;
}

// ======================================================================
void afficher(Recette const& r)
{
  cout << "Pour faire une " << r.titre << " pour " << r.nb_convives << " personne(s), " << endl;
  cout << "il vous faut : " << endl;
  for (auto& ingredient : r.ingredients) {
    cout << " - ";
    afficher(ingredient);
    cout << endl;
  }
}

// ======================================================================
int main()
{
  const Recette r = {
    "fondue fribourgeoise",
    4,
    { { "fromage", 800.0, "g"  },
      { "eau",       2.0, "dl" },
      { "ail",       2.0, "gousse" },
      { "pain",    400.0, "g"  } }
    };
  
  afficher( adapter(r, demander_nb_convives()));
  
  return 0;
}

